您的位置:首页 > 其它

HDU-2955 Robberies (01背包 入门题)

2017-10-27 15:33 411 查看


Robberies

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 26230    Accepted Submission(s): 9674


Problem Description

The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before
retiring to a comfortable job at a university.



For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.

His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.

 

Input

The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line
j gives an integer Mj and a floating point number Pj . 

Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .

 

Output

For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints

0 < T <= 100

0.0 <= P <= 1.0

0 < N <= 100

0 < Mj <= 100

0.0 <= Pj <= 1.0

A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.

 

Sample Input

3
0.04 3
1 0.02
2 0.03
3 0.05
0.06 3
2 0.03
2 0.03
3 0.05
0.10 3
1 0.03
2 0.02
3 0.05

 

Sample Output

2
4
6

 

#include <bits/stdc++.h>
using namespace std;
int m[101];
double p[101], dp[10001];
int main(){
int T;
scanf("%d", &T);
while(T--){
double P;
int n, tot = 0;
scanf("%lf %d", &P, &n);
for(int i = 1; i <= n; ++i){
scanf("%d %lf", &m[i], &p[i]);
tot += m[i];
}
dp[0] = 1.0;
for(int i = 1; i <= tot; ++i){
dp[i] = 0;
}
for(int i = 1; i <= n; ++i){
for(int j = tot; j >= m[i]; --j){
dp[j] = max(dp[j], dp[j - m[i]] * (1.0 - p[i]));
}
}
for(int i = tot; i >= 0; --i){
if(1 - dp[i] <= P){
printf("%d\n", i);
break;
}
}
}
}

/*
题意:小偷去100家银行,偷每家都有被抓概率被抓,概率p[i],偷不同银行的事件之间相互独立。
现在小偷希望偷到更多的钱,但是被抓的概率不能超过P,问最多能偷多少钱。

思路:这题有明显的01背包的感觉,唯一不同的是这题转移用的是乘法。。。dp[i]表示偷i元最大可以
有多少的概率不被抓,因为不被抓的概率直接算相对麻烦,不如一步到位直接求不被抓的概率,这样
最后从大到小遍历i,1 - dp[i] <= p时的i就是最多能偷多少了。
转移方程:dp[j] = max(dp[j], dp[j - m[i]] * (1.0 - p[i]))。
*/
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  hdu 01背包 acm